Description

In the 'DB Manager' the create table dialog misses data type 'Serial' for SpatiaLite connections.

Related issues:

Related to QGIS Application - Bug report # 15079: New PostGIS/SpatiaLite tabl... Closed 2016-06-19

Associated revisions

Revision 318a8350 - 2016-06-21 11:46 AM - Matthias Kuhn 

Default to creating an autoincrement primary key for spatialite

References #15071 (https://hub.qgis.org/issues/15071)

History

#1 - 2016-06-19 02:54 AM - Jukka Rahkonen

SQLite does not have datatype "serial". INTEGER PRIMARY KEY [AUTOINCREMENT] comes closest to that. No other column than the primary key one

can be autoincremented.

http://www.sqlite.com/datatype3.html

http://www.sqlite.com/lang_createtable.html#rowid

https://sqlite.org/autoinc.html

For my mind this is not a bug in QGIS.

#2 - 2016-06-19 03:55 AM - R. R.

I've just noticed that for new SpatiaLite tables an auto incrementing primary key (data type 'integer') is created automatically. For new PostGIS tables users

have to set the data type to 'serial'. So this is neither a bug nor a missing feature, just the interface is a bit confusing. Feel free to close this ticket.

#3 - 2016-06-20 04:13 AM - Jukka Rahkonen

PostgreSQL/PostGIS and SQLite/SpatiaLite are rather alike but they are not at all identical.

In SQLite there is no choice in this case because "column INTEGER PRIMARY KEY" takes the values automatically from the same place as the ROWID.

In PostgreSQL it is possible and valid to have PK in integer column which does not take values from a sequence.

#4 - 2016-06-21 02:47 AM - Matthias Kuhn
- Status changed from Open to Closed

If you have any idea how to improve the confusing interface, please open a new issue.

#5 - 2016-06-21 11:49 AM - R. R.

Most likely this is not an issue of high priority. However, here is my proposal to fix it: #15079-2

#6 - 2017-05-19 09:09 AM - Jürgen Fischer

- Related to Bug report #15079: New PostGIS/SpatiaLite table - Inconsistent  behavior of primary keys added
